OpenShot Audio Library | OpenShotAudio: juce::WebInputStream Class Reference

OpenShot Audio Library | OpenShotAudio 0.3.1

Loading...
Searching...
No Matches
Classes | Public Member Functions | List of all members
juce::WebInputStream Class Reference

`#include <juce_WebInputStream.h>`

Inheritance diagram for juce::WebInputStream:

## Classes
class | Listener

## Public Member Functions
| WebInputStream (const URL &url, const bool usePost)
WebInputStream & | withExtraHeaders (const String &extraHeaders)
WebInputStream & | withCustomRequestCommand (const String &customRequestCommand)
WebInputStream & | withConnectionTimeout (int timeoutInMs)
WebInputStream & | withNumRedirectsToFollow (int numRedirects)
StringPairArray | getRequestHeaders () const
StringPairArray | getResponseHeaders ()
int | getStatusCode ()
bool | connect (Listener *listener)
bool | isError () const
void | cancel ()
int64 | getTotalLength () override
int | read (void *destBuffer, int maxBytesToRead) override
bool | isExhausted () override
int64 | getPosition () override
bool | setPosition (int64 wantedPos) override
Public Member Functions inherited from juce::InputStream
virtual | ~InputStream ()=default
virtual int64 | getTotalLength ()=0
int64 | getNumBytesRemaining ()
virtual bool | isExhausted ()=0
virtual int | read (void *destBuffer, int maxBytesToRead)=0
ssize_t | read (void *destBuffer, size_t maxBytesToRead)
virtual char | readByte ()
virtual bool | readBool ()
virtual short | readShort ()
virtual short | readShortBigEndian ()
virtual int | readInt ()
virtual int | readIntBigEndian ()
virtual int64 | readInt64 ()
virtual int64 | readInt64BigEndian ()
virtual float | readFloat ()
virtual float | readFloatBigEndian ()
virtual double | readDouble ()
virtual double | readDoubleBigEndian ()
virtual int | readCompressedInt ()
virtual String | readNextLine ()
virtual String | readString ()
virtual String | readEntireStreamAsString ()
virtual size_t | readIntoMemoryBlock (MemoryBlock &destBlock, ssize_t maxNumBytesToRead=-1)
virtual int64 | getPosition ()=0
virtual bool | setPosition (int64 newPosition)=0
virtual void | skipNextBytes (int64 numBytesToSkip)

## Detailed Description

An InputStream which can be used to read from a given url.

Definition at line 32 of file juce_WebInputStream.h.

## Constructor & Destructor Documentation

## ◆ WebInputStream()

juce::WebInputStream::WebInputStream | ( | const URL & | url,
|  | const bool | usePost
| ) |  |

Creates a new WebInputstream which can be used to read from a url.

Parameters

  url | The url that should be retrieved. This parameter may also contain post data and/or parameters.
  usePost | Specifies whether a GET or a POST command should be used. This parameter will also influence the way parameters are encoded.

Definition at line 26 of file juce_WebInputStream.cpp.

## ◆ ~WebInputStream()

juce::WebInputStream::~WebInputStream | ( |  | ) |
| override

Definition at line 31 of file juce_WebInputStream.cpp.

## Member Function Documentation

## ◆ cancel()

void juce::WebInputStream::cancel | ( |  | ) |

Will cancel a blocking read and prevent any subsequent connection attempts.

Definition at line 43 of file juce_WebInputStream.cpp.

## ◆ connect()

bool juce::WebInputStream::connect | ( | Listener * | listener | ) |

Wait until the first byte is ready for reading

This method will attempt to connect to the url given in the constructor and block until the status code and all response headers have been received or an error has occurred.

Note that most methods will call connect internally if they are called without an established connection. Therefore, it is not necessary to explicitly call connect unless you would like to use a custom listener.

After a successful call to connect, getResponseHeaders, getTotalLength and getStatusCode will all be non-blocking.

Parameters

  listener | A listener to receive progress callbacks on the status of a POST data upload.

See also
  getResponseHeaders, getTotalLength, getStatusCode

Definition at line 51 of file juce_WebInputStream.cpp.

Referenced by getResponseHeaders(), getStatusCode(), getTotalLength(), and read().

## ◆ getPosition()

int64 juce::WebInputStream::getPosition | ( |  | ) |
| overridevirtual

Returns the offset of the next byte that will be read from the stream.

See also
  setPosition

Implements juce::InputStream.

Definition at line 45 of file juce_WebInputStream.cpp.

## ◆ getRequestHeaders()

StringPairArray juce::WebInputStream::getRequestHeaders | ( |  | ) | const

Returns a string array pair of the request headers

Definition at line 40 of file juce_WebInputStream.cpp.

## ◆ getResponseHeaders()

StringPairArray juce::WebInputStream::getResponseHeaders | ( |  | ) |

Returns a string array pair of response headers

If getResponseHeaders is called without an established connection, then getResponseHeaders will call connect internally and block until connect returns - either due to a successful connection or a connection error.

See also
  connect

Definition at line 41 of file juce_WebInputStream.cpp.

## ◆ getStatusCode()

int juce::WebInputStream::getStatusCode | ( |  | ) |

Returns the status code returned by the http server

If getStatusCode is called without an established connection, then getStatusCode will call connect internally and block until connect returns - either due to a successful connection or a connection error.

See also
  connect

Definition at line 49 of file juce_WebInputStream.cpp.

## ◆ getTotalLength()

int64 juce::WebInputStream::getTotalLength | ( |  | ) |
| overridevirtual

Returns the total number of bytes available for reading in this stream.

Note that this is the number of bytes available from the start of the stream, not from the current position.

If getTotalLength is called without an established connection, then getTotalLength will call connect internally and block until connect returns - either due to a successful connection or a connection error.

If the size of the stream isn't actually known, this will return -1.

Implements juce::InputStream.

Definition at line 46 of file juce_WebInputStream.cpp.

## ◆ isError()

bool juce::WebInputStream::isError | ( |  | ) | const

Returns true if there was an error during the connection attempt.

Definition at line 42 of file juce_WebInputStream.cpp.

Referenced by connect().

## ◆ isExhausted()

bool juce::WebInputStream::isExhausted | ( |  | ) |
| overridevirtual

Returns true if the stream has no more data to read.

Implements juce::InputStream.

Definition at line 44 of file juce_WebInputStream.cpp.

## ◆ read()

int juce::WebInputStream::read | ( | void * | destBuffer,
|  | int | maxBytesToRead
| ) |  |
| overridevirtual

Reads some data from the stream into a memory buffer.

This method will block until the bytesToRead bytes are available.

This method calls connect internally if the connection hasn't already been established.

Parameters

  destBuffer | the destination buffer for the data. This must not be null.
  maxBytesToRead | the maximum number of bytes to read - make sure the memory block passed in is big enough to contain this many bytes. This value must not be negative.

Returns
  the actual number of bytes that were read, which may be less than maxBytesToRead if the stream is exhausted before it gets that far

Implements juce::InputStream.

Definition at line 47 of file juce_WebInputStream.cpp.

## ◆ setPosition()

bool juce::WebInputStream::setPosition | ( | int64 | wantedPos | ) |
| overridevirtual

Tries to move the current read position of the stream.

The position is an absolute number of bytes from the stream's start.

For a WebInputStream, this method will fail if wantedPos is smaller than the current position. If wantedPos is greater than the current position, then calling setPosition is the same as calling read, i.e. the skipped data will still be downloaded, although skipped bytes will be discarded immediately.

Returns
  true if the stream manages to reposition itself correctly

See also
  getPosition

Implements juce::InputStream.

Definition at line 48 of file juce_WebInputStream.cpp.

## ◆ withConnectionTimeout()

WebInputStream & juce::WebInputStream::withConnectionTimeout | ( | int | timeoutInMs | ) |

Specify the connection time-out

Returns a reference to itself so that several methods can be chained.

Parameters

  timeoutInMs | the number of milliseconds to wait until the connection request is aborted.

Definition at line 38 of file juce_WebInputStream.cpp.

## ◆ withCustomRequestCommand()

WebInputStream & juce::WebInputStream::withCustomRequestCommand | ( | const String & | customRequestCommand | ) |

Override the http command that is sent

Returns a reference to itself so that several methods can be chained.

Note that this command will not change the way parameters are sent. This must be specified in the constructor.

Parameters

  customRequestCommand | this string is the custom http request command such as POST or GET.

Definition at line 37 of file juce_WebInputStream.cpp.

## ◆ withExtraHeaders()

WebInputStream & juce::WebInputStream::withExtraHeaders | ( | const String & | extraHeaders | ) |

Add extra headers to http request

Returns a reference to itself so that several methods can be chained.

Parameters

  extraHeaders | this string is appended onto the headers that are used for the request. It must therefore be a valid set of HTML header directives, separated by newlines.

Definition at line 36 of file juce_WebInputStream.cpp.

## ◆ withNumRedirectsToFollow()

WebInputStream & juce::WebInputStream::withNumRedirectsToFollow | ( | int | numRedirects | ) |

Specify the number of redirects to be followed

Returns a reference to itself so that several methods can be chained.

Parameters

  numRedirects | specifies the number of redirects that will be followed before returning a response (ignored for Android which follows up to 5 redirects)

Definition at line 39 of file juce_WebInputStream.cpp.

The documentation for this class was generated from the following files:

- juce_WebInputStream.h
- juce_WebInputStream.cpp